<template>
  <v-card
    :dark="jsonViewerOptions.theme"
    v-if="dataValue"
  >
    <v-card-title class="py-1 d-flex align-center">
      <slot name="header"></slot>
      <v-switch
        class="ma-2 align-center"
        v-model="viewJson"
        :dark="jsonViewerOptions.theme"
        :label="(viewJson) ? 'Json' : 'Estrutura'"

        hide-details
      ></v-switch>
      <v-switch
        class="ma-2 align-center"
        v-model="jsonViewerOptions.theme"
        :dark="jsonViewerOptions.theme"
        :label="(!! jsonViewerOptions.theme) ? 'Escuro' : 'Claro'"

        hide-details
      ></v-switch>
    </v-card-title>
    <v-card-text :style="bodyStyle">
      <v-textarea
        outlined
        rows="8"
        v-if="viewJson"
        :value="JSON.stringify(dataValue, null, 2)"
      >
      </v-textarea>
      <tree-view
        v-else
        style="overflow: initial;"
        :data="dataValue"
        :options="jsonViewerOptions"
      />
    </v-card-text>
  </v-card>
</template>

<script>
export default {
  name: "JsonViewer",
  props: {
    jsonViewerOptions: {
      type: Object,
      default: function () {
        return {dark: false}
      },
    },
    dataValue:{},
    bodyStyle: {
      type: String,
      default: "max-height: 400px; overflow: scroll;"
    }
  },
  data(){
    return{
      cardDark: false,
      viewJson: false
    }
  },
  watch:{
    jsonViewerOptions:{
      immediate: true,
      deep: true,
      handler(newValue){
        this.cardDark = newValue
      }
    }
  }
}
</script>

<style>
.tree-view-item-key {
  color: black;
}
.tree-view-item-value-string{
  color: blue;
}
.theme--dark .tree-view-item-value-string{
  color: lightseagreen;
}
.theme--dark .tree-view-item-key {
  color: white;
}

.theme--dark>.v-card__title{
  background-color:#333;
}
.v-card__title {
  background-color: #dadada;
}

</style>